var Promise = require("q");
var integerRegExp = /^\d+$/;
function simpleLocatorFactory() {
    function simpleLocator(parameters) {
        if (typeof parameters === "string") {
            parameters = { resource: parameters };
        }
        var resource = parameters.resource;
        var defaultPort = parameters.defaultPort;
        if (!resource) {
            throw new Error("must have resource");
        }
        var locations = resource.split(";").map(function (locationString) {
            var parts = locationString.split(":");
            if (parts.length > 2) {
                throw new Error("invalid resource part '" + locationString + "'");
            }
            var location = {
                host: parts[0]
            };
            if (parts.length === 2) {
                if (!integerRegExp.test(parts[1])) {
                    throw new Error("invalid port in resource '" + parts[1] + "'");
                }
                location.port = Number(parts[1]);
            }
            else if (defaultPort) {
                location.port = defaultPort;
            }
            return location;
        });
        return function () { return Promise(locations[Math.floor(Math.random() * locations.length)]); };
    }
    return simpleLocator;
}
exports.simpleLocatorFactory = simpleLocatorFactory;
